;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	XPLODE.LSP  VER. 1.3-A
;	(C) COPR. 1989,90,   MWB DESIGN GROUP, INC.     ALL RIGHTS RESERVED.
;	ACAD VER. 10
;
;	PROGRAM WILL EXPLODE ANY BLOCK REGARDLESS OF IT'S XYZ SCALE FACTORS
;
;	ALL EXPLODED OBJECTS WILL RETAIN THEIR ORIGINAL ENTITY TYPE EXCEPT
;	FOR ARCS AND CIRCLES THAT HAVE BEEN INSERTED AT DIFFERENT XY SCALE
;	FACTORS (Z IRRELEVANT). THESE ITEMS WILL BE CHANGED INTO ELLIPSES.
;
;	WIDE POLYLINES AND SHAPES INTERNAL TO BLOCKS WILL RETAIN THEIR
;	CORRECT SIZE RATIO UNLESS THE BLOCK WAS INSERTED AT DIFFERENT XY
;	FACTORS (Z IRRELEVANT).
;
;	ANSWERING YES TO THE "EXPLODE NESTED OBJECTS" PROMPT WILL CAUSE
;	ALL LEVELS OF NESTED OBJECTS TO BE EXPLODED. THIS WILL PROCEED
;	REGARDLESS OF THE QUANTITY OR LEVEL OF NESTING.
;
;	ANSWERING YES TO THE "BLOCKS ONLY" PROMPT WILL CAUSE THE PROGRAM
;	TO EXPLODE ONLY BLOCKS. POLYLINES AND DIMENSIONS WILL NOT BE
;	EXPLODED. NOTE: HATCH PATTERNS ARE BLOCKS (UN-NAMED BLOCKS) AND
;	WILL BE EXPLODED REGARDLESS OF THE ANSWER TO THIS QUESTION.
;
;	ANSWERING YES TO THE "RETAIN ATTRIBUTE VALUES" PROMPT WILL CAUSE
;	THE PROGRAM TO CHANGE THE TAG OF EACH ATTRIBUTE DEFINITION SO IT 
;	MATCHES (AND LOOKS LIKE) THE ORIGINAL ATTRIBUTE. IF THE STATUS
;	OF THE CURRENT ATTRIBUTE DISPLAY IS ANYTHING BUT "NORMAL", THE
;	PROGRAM WILL CONFIRM IF THE CURRENT MODE IS TO BE MATCHED. IF NO,
;	THEN THE NORMAL MODE WILL BE USED. (INVISIBLE ATTRIBUTES WILL BE
;	DELETED).
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(DEFUN C:XPLODE (/ A B C D E G F H I J K L M PT1 PT2 PT3 PT4 PT5 PT6 EN EN1 EN2 ENT ENT1 ENT2 ENTSS ENTSS1 BLIP HIGH FLAT UCSF CLAY CECO CELT THIC EXPE # $)
(PROMPT "\n(C) COPR. 1989,90,      MWB DESIGN GROUP, INC.        ALL RIGHTS RESERVED.")
(INITGET "Yes No")
(IF (= "Yes" (GETKWORD "\nExplode nested Objects ? <No>/Yes: ")) (SETQ A T) (SETQ A NIL))
(INITGET "Yes No")
(IF (= "Yes" (GETKWORD "\nBlocks only ? <No>/Yes: ")) (SETQ M T) (SETQ M NIL))
(INITGET "Yes No")
(IF (= "Yes" (GETKWORD "\nRetain Attribute values ? <No>/Yes: ")) (SETQ B T) (SETQ B NIL))
(IF (AND B (/= 1 (GETVAR "ATTMODE"))) (PROGN
	(INITGET "Yes No")
	(IF (= "Yes" (GETKWORD "\nMatch current Attribute Display mode ? <No>/Yes: ")) (SETQ B (GETVAR "ATTMODE")))
))
(IF (SETQ ENTSS (SSGET)) (PROGN 
	(SETQ 
		BLIP (GETVAR "BLIPMODE") 
		HIGH (GETVAR "HIGHLIGHT") 
		FLAT (GETVAR "FLATLAND") 
		UCSF (GETVAR "UCSFOLLOW")
		CLAY (GETVAR "CLAYER") 
		CECO (ATOI (GETVAR "CECOLOR")) 
		CELT (GETVAR "CELTYPE") 
		THIC (GETVAR "THICKNESS")
		EXPE (GETVAR "EXPERT")
	)
	(IF (= 0 CECO) (SETQ CECO (GETVAR "CECOLOR")))
	(SETVAR "CMDECHO" (SETVAR "BLIPMODE" (SETVAR "HIGHLIGHT" (SETVAR "FLATLAND" (SETVAR "UCSFOLLOW" 0)))))
	(SETVAR "EXPERT" 4)
	(COMMAND ".UCS" "S" "TEMPMWB" ".LINETYPE" "S" "CONTINUOUS" "")
	(SETQ # 0.0 ENT (SSNAME ENTSS #))
	(WHILE ENT
		(SETQ EN (ENTGET ENT))
		(IF (= "INSERT" (CDR (ASSOC 0 EN))) (PROGN 
			(SETQ 
				C (CDR (ASSOC 41 EN)) 
				D (CDR (ASSOC 42 EN)) 
				E (CDR (ASSOC 43 EN))
				F (NULL (= 0 (CDR (ASSOC 70 EN)) (CDR (ASSOC 71 EN))))
			)
			(IF (OR (NULL (= C D E)) F) (PROGN 
				(COMMAND ".UCS" "E" ENT)
				(SETQ 
					PT1 (LIST C D E)
					EN (ENTGET ENT)
					PT2 (TRANS (CDR (ASSOC 10 EN)) ENT 1)
					EN (SUBST (CONS 41 1.0) (ASSOC 41 EN) EN)
					EN (SUBST (CONS 42 1.0) (ASSOC 42 EN) EN)
					EN (SUBST (CONS 43 1.0) (ASSOC 43 EN) EN)
				)
				(IF F (SETQ
					G (CDR (ASSOC 44 EN))
					H (CDR (ASSOC 45 EN))
					I (CDR (ASSOC 70 EN))
					J (CDR (ASSOC 71 EN))
					EN (SUBST (CONS 44 0.0) (ASSOC 44 EN) EN)
					EN (SUBST (CONS 45 0.0) (ASSOC 45 EN) EN)
					EN (SUBST (CONS 70 0) (ASSOC 70 EN) EN)
					EN (SUBST (CONS 71 0) (ASSOC 71 EN) EN)
				))
				(ENTMOD EN)
				(IF (AND B (/= 0 B) (ENTNEXT ENT)) (SETQ K (XPLODE2 ENT NIL NIL)))
				(COMMAND ".POINT" (GETVAR "VIEWCTR"))
				(SETQ 
					ENT2 (ENTLAST)
					ENT1 ENT2
					ENTSS1 NIL 
					ENTSS1 (SSADD)
				)
				(IF F (PROGN 
					(COMMAND ".COPY" ENT "" "0,0,0" "0,0,0")
					(ENTDEL ENT)
					(SSADD (ENTLAST) ENTSS1) 
					(REDRAW (ENTLAST) 1)
					(COMMAND ".ARRAY" (ENTLAST) "" "R" J I (/ H D) (/ G C))
				) (COMMAND ".EXPLODE" ENT))
				(WHILE (SETQ ENT1 (ENTNEXT ENT1)) (SSADD ENT1 ENTSS1))
				(ENTDEL ENT2)
				(IF (= (ABS C) (ABS D) E) 
					(PROGN
						(COMMAND ".MIRROR" ENTSS1 "" "0,0")
						(IF (> D 0.0 C) (COMMAND "0,1" "Y") (COMMAND "1,0" "Y"))
						(IF (/= 1.0 (ABS C)) (COMMAND ".SCALE" ENTSS1 "" "0,0" (ABS C)))
					)
					(PROGN
						(SETQ $ (1- (SSLENGTH ENTSS1)) ENT1 (SSNAME ENTSS1 $))
						(WHILE (>= $ 0)
							(XPLODE3 NIL) 
							(SETQ $ (1- $) ENT1 (SSNAME ENTSS1 $))
						)
					)
				)
				(SETQ ENT NIL)
			))
		))
		(IF (AND ENT (OR (= "INSERT" (SETQ C (CDR (ASSOC 0 EN)))) (AND (NULL M) (MEMBER C '("DIMENSION" "POLYLINE"))))) (PROGN
			(IF (AND (= "INSERT" C) B (/= 0 B) (ENTNEXT ENT)) (SETQ K (XPLODE2 ENT NIL NIL)))
			(COMMAND ".POINT" (GETVAR "VIEWCTR"))
			(SETQ ENT1 (SETQ ENT2 (ENTLAST)))
			(COMMAND ".EXPLODE" ENT)
			(IF (OR A B) (WHILE (SETQ ENT1 (ENTNEXT ENT1))
				(IF (AND B (= "INSERT" C) (= "ATTDEF" (SETQ L (CDR (ASSOC 0 (SETQ EN1 (ENTGET ENT1))))))) (XPLODE3 T))
				(IF (AND A (ENTGET ENT1)) (SSADD ENT1 ENTSS))
			))
			(ENTDEL ENT2)
		))
		(SETQ # (1+ #) ENT (SSNAME ENTSS #))
	)
	(COMMAND 
		".COLOR" CECO
		".LAYER" "S" CLAY ""
		".UCS" "R" "TEMPMWB" 
		".UCS" "D" "TEMPMWB" 
		".LINETYPE" "S" CELT ""
	)
	(SETVAR "BLIPMODE" BLIP) 
	(SETVAR "HIGHLIGHT" HIGH) 
	(SETVAR "FLATLAND" FLAT) 
	(SETVAR "UCSFOLLOW" UCSF)
	(SETVAR "EXPERT" EXPE)
	(SETVAR "THICKNESS" THIC)
))
(PRINC)
)
(DEFUN XPLODE2 (X Y Z)
(IF Y 
	(PROGN
		(IF (AND Z (SETQ G (CDR (ASSOC 39 EN1))) (/= 0.0 G)) (SETQ EN1 (SUBST (CONS 39 (* E G)) (ASSOC 39 EN1) EN1)))
		(SETQ 
			PT3 (MAPCAR '- (TRANS (CDR (SETQ G (ASSOC X EN1))) ENT1 1) Y)
			PT4 (MAPCAR '* PT3 PT1)
			EN1 (SUBST (CONS X (TRANS (MAPCAR '+ PT4 Y) 1 ENT1)) G EN1)
		)
	)
	(PROGN
		(SETQ ENT2 (ENTNEXT X))
		(WHILE (= "ATTRIB" (CDR (ASSOC 0 (SETQ EN2 (ENTGET ENT2))))) 
			(SETQ Y (APPEND Y (LIST (LIST 
				(CDR (ASSOC 2 EN2)) 
				(CDR (ASSOC 1 EN2)) 
			))))
			(SETQ ENT2 (ENTNEXT ENT2))
		)
		(SETQ ENT2 (CDR (ASSOC -2 (TBLSEARCH "BLOCK" (CDR (ASSOC 2 (ENTGET X)))))))
		(WHILE ENT2
			(SETQ EN2 (ENTGET ENT2))
			(IF 
				(AND
					(= "ATTDEF" (CDR (ASSOC 0 EN2))) 
					(NULL (ASSOC (CDR (ASSOC 2 EN2)) Y))
				)
				(SETQ Y (APPEND Y (LIST (LIST 
					(CDR (ASSOC 2 EN2)) 
					(CDR (ASSOC 1 EN2)) 
				))))
			)
			(SETQ ENT2 (ENTNEXT ENT2))
		)
		 Y 
	)
)
)
(DEFUN XPLODE3 (X)
(SETQ EN1 (ENTGET ENT1))
(COND
	((= "INSERT" (SETQ L (CDR (ASSOC 0 EN1))))
		(IF A (SSADD ENT1 ENTSS))
		(SETQ 
			EN1 (SUBST (CONS 41 (* (CDR (SETQ G (ASSOC 41 EN1))) C)) G EN1)
			EN1 (SUBST (CONS 42 (* (CDR (SETQ G (ASSOC 42 EN1))) D)) G EN1)
			EN1 (SUBST (CONS 43 (* (CDR (SETQ G (ASSOC 43 EN1))) E)) G EN1)
		)
		(XPLODE2 10 PT2 NIL)
		(ENTMOD EN1)
	)
	((MEMBER L '("LINE" "SOLID" "3DFACE" "TRACE" "3DLINE" "POINT"))
		(IF (AND (SETQ G (CDR (ASSOC 39 EN1))) (/= 0.0 G)) (SETQ EN1 (SUBST (CONS 39 (* E G)) (ASSOC 39 EN1) EN1)))
		(FOREACH X '(10 11 12 13) (IF (ASSOC X EN1) (XPLODE2 X PT2 NIL)))
		(ENTMOD EN1)
	)
	((AND (= "POLYLINE" L) (= 0 (LOGAND 24 (CDR (ASSOC 70 EN1)))))
		(IF A (SSADD ENT1 ENTSS))
		(IF (/= 0.0 (SETQ G (CDR (ASSOC 40 EN1)))) (COMMAND ".PEDIT" ENT1 "W" (ABS (* D G)) "X"))
		(WHILE (AND ENT1 (/= "SEQEND" L))
			(SETQ EN1 (ENTGET ENT1))
			(XPLODE2 10 PT2 T)
			(ENTMOD EN1)
			(SETQ EN1 (ENTGET (SETQ ENT1 (ENTNEXT ENT1))) L (CDR (ASSOC 0 EN1)))
		)
		(ENTUPD ENT1)
	)
	((= "POLYLINE" L)
		(IF A (SSADD ENT1 ENTSS))
		(WHILE (/= "SEQEND" L)
			(XPLODE2 10 PT2 NIL)
			(ENTMOD EN1)
			(SETQ EN1 (ENTGET (SETQ ENT1 (ENTNEXT ENT1))) L (CDR (ASSOC 0 EN1)))
		)
		(ENTUPD ENT1)
	)
	((= "SHAPE" L)
		(SETQ EN1 (SUBST (CONS 40 (* C (CDR (ASSOC 40 EN1)))) (ASSOC 40 EN1) EN1))
		(XPLODE2 10 PT2 T)
		(ENTMOD EN1)
	)
	((MEMBER L '("ARC" "CIRCLE"))
		(IF (= (ABS C) (ABS D)) (PROGN
			(SETQ EN1 (SUBST (CONS 40 (* (ABS C) (CDR (ASSOC 40 EN1)))) (ASSOC 40 EN1) EN1))
			(IF (AND (= "ARC" L) (/= C D)) (SETQ
				G (CDR (ASSOC 50 EN1))
				EN1 (SUBST (CONS 50 (- PI (CDR (ASSOC 51 EN1)))) (ASSOC 50 EN1) EN1)
				EN1 (SUBST (CONS 51 (- PI G)) (ASSOC 51 EN1) EN1)
			))
			(XPLODE2 10 PT2 T)
			(ENTMOD EN1)
		) (XPLODE4))
	)
	((MEMBER L '("ATTDEF" "TEXT" "ATTRIB"))
		(COND
			((AND (= "ATTDEF" L) (= 0 B)) (ENTDEL ENT1))
			((AND (= "ATTDEF" L) B (/= 2 B) (= 1 (LOGAND 1 (CDR (ASSOC 70 EN1))))) (ENTDEL ENT1))
			(T
				(IF (NULL X) (PROGN
					(XPLODE2 10 PT2 T)
					(XPLODE2 11 PT2 NIL)
					(SETQ 
						PT3 '(0.0 0.0 0.0)
						G (CDR (ASSOC 40 EN1)) 
						H (CDR (ASSOC 50 EN1)) 
						PT4 (MAPCAR '* PT1 (POLAR PT3 (+ H (/ PI 2.0)) G))
						PT5 (MAPCAR '* PT1 (POLAR PT3 H (CDR (ASSOC 41 EN1))))
						PT6 (MAPCAR '* PT1 (POLAR PT3 (- (+ H (/ PI 2.0)) (CDR (ASSOC 51 EN1))) G))
						I (ANGLE PT3 PT5)
						EN1 (SUBST (CONS 40 (SETQ J (* (DISTANCE PT3 PT4) (ABS (SIN (- (ANGLE PT3 PT4) I)))))) (ASSOC 40 EN1) EN1)
						EN1 (SUBST (CONS 41 (* (DISTANCE PT3 PT5) (/ G J))) (ASSOC 41 EN1) EN1)
						EN1 (SUBST (CONS 50 I) (ASSOC 50 EN1) EN1)
						EN1 (SUBST (CONS 51 (- (/ PI 2) (- (ANGLE PT3 PT6) I))) (ASSOC 51 EN1) EN1)
					)
					(COND 
						((> C 0.0 D)
							(SETQ EN1 (SUBST (CONS 71 (IF (= 0 (LOGAND 2 (SETQ G (CDR (ASSOC 71 EN1))))) (+ G 2) (- G 2))) (ASSOC 71 EN1) EN1))
							(SETQ EN1 (SUBST (CONS 51 (- (SETQ G (CDR (ASSOC 51 EN1))) (* 2.0 (- G PI)))) (ASSOC 51 EN1) EN1))
						)
						((> D 0.0 C) 
							(SETQ EN1 (SUBST (CONS 71 (IF (= 0 (LOGAND 4 (SETQ G (CDR (ASSOC 71 EN1))))) (+ G 4) (- G 4))) (ASSOC 71 EN1) EN1))
							(SETQ EN1 (SUBST (CONS 51 (- (SETQ G (CDR (ASSOC 51 EN1))) (* 2.0 (- G PI)))) (ASSOC 51 EN1) EN1))
						)
					)
				))
				(IF (AND B (= "ATTDEF" L)) (PROGN
					(IF (SETQ G (CADR (ASSOC (CDR (ASSOC 2 EN1)) K))) (SETQ EN1 (SUBST (CONS 2 G) (ASSOC 2 EN1) EN1)))
				))
				(ENTMOD EN1)
			)
		)
	)
)
)
(DEFUN XPLODE4 ()
(SETQ G (COND
	((NULL (SETQ G (CDR (ASSOC 62 EN1)))) "BYLAYER")
	((= 0 G) 7)
	(T G)
))
(COND
	((AND (= (SETQ H (GETVAR "CECOLOR")) G) (= 'STR (TYPE G))) (SETQ H NIL))
	((AND (= 'INT (TYPE G)) (= (ATOI H) G)) (SETQ G NIL))
)
(IF H (COMMAND ".COLOR" G))
(IF (/= (GETVAR "CLAYER") (SETQ G (CDR (ASSOC 8 EN1)))) (COMMAND ".LAYER" "S" G ""))
(SETVAR "THICKNESS" (COND ((CDR (ASSOC 39 EN1))) (0.0)))
(SETQ PT3 (CDR (ASSOC 10 EN1)) G (CDR (ASSOC 40 EN1)))
(IF (= "ARC" L)
	(SETQ PT4 (POLAR PT3 (SETQ I (CDR (ASSOC 50 EN1))) G) J (CDR (ASSOC 51 EN1)))
	(SETQ PT4 (POLAR PT3 (SETQ I 0.0) G) J (* PI 2))
)
(SETQ H (/ (- (IF (< J I) (SETQ J (+ J (* PI 2))) J) I) 8))
(COMMAND ".PLINE" (TRANS PT4 ENT1 1) "W" "0" "0")
(REPEAT 7
	(COMMAND (TRANS (POLAR PT3 (SETQ I (+ I H)) G) ENT1 1))
)
(IF (= "ARC" L) (COMMAND (TRANS (POLAR PT3 (+ I H) G) ENT1 1) "") (COMMAND "C"))
(ENTDEL ENT1)
(SETQ EN2 (ENTGET (SETQ ENT2 (ENTLAST))) EN1 (ENTGET (SETQ ENT1 (ENTNEXT ENT2))))
(WHILE (/= "SEQEND" (CDR (ASSOC 0 EN1))) 
	(XPLODE2 10 PT2 NIL) 
	(ENTMOD EN1) 
	(SETQ EN1 (ENTGET (SETQ ENT1 (ENTNEXT ENT1))))
)
(SETQ EN1 EN2 ENT1 ENT2)
(XPLODE2 10 PT2 T)
(ENTMOD EN1)
(COMMAND ".PEDIT" ENT1 "F" "X")
)
'LOADED
